# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from mtmai.clients.rest.models.assistant_message import AssistantMessage
from mtmai.clients.rest.models.function_execution_result_message import FunctionExecutionResultMessage
from mtmai.clients.rest.models.system_message import SystemMessage
from mtmai.clients.rest.models.user_message import UserMessage
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

LLMMESSAGE_ONE_OF_SCHEMAS = ["AssistantMessage", "FunctionExecutionResultMessage", "SystemMessage", "UserMessage"]

class LlmMessage(BaseModel):
    """
    LlmMessage
    """
    # data type: UserMessage
    oneof_schema_1_validator: Optional[UserMessage] = None
    # data type: SystemMessage
    oneof_schema_2_validator: Optional[SystemMessage] = None
    # data type: AssistantMessage
    oneof_schema_3_validator: Optional[AssistantMessage] = None
    # data type: FunctionExecutionResultMessage
    oneof_schema_4_validator: Optional[FunctionExecutionResultMessage] = None
    actual_instance: Optional[Union[AssistantMessage, FunctionExecutionResultMessage, SystemMessage, UserMessage]] = None
    one_of_schemas: Set[str] = { "AssistantMessage", "FunctionExecutionResultMessage", "SystemMessage", "UserMessage" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = LlmMessage.model_construct()
        error_messages = []
        match = 0
        # validate data type: UserMessage
        if not isinstance(v, UserMessage):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UserMessage`")
        else:
            match += 1
        # validate data type: SystemMessage
        if not isinstance(v, SystemMessage):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SystemMessage`")
        else:
            match += 1
        # validate data type: AssistantMessage
        if not isinstance(v, AssistantMessage):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AssistantMessage`")
        else:
            match += 1
        # validate data type: FunctionExecutionResultMessage
        if not isinstance(v, FunctionExecutionResultMessage):
            error_messages.append(f"Error! Input type `{type(v)}` is not `FunctionExecutionResultMessage`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in LlmMessage with oneOf schemas: AssistantMessage, FunctionExecutionResultMessage, SystemMessage, UserMessage. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in LlmMessage with oneOf schemas: AssistantMessage, FunctionExecutionResultMessage, SystemMessage, UserMessage. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `AssistantMessage`
        if _data_type == "AssistantMessage":
            instance.actual_instance = AssistantMessage.from_json(json_str)
            return instance

        # check if data type is `FunctionExecutionResultMessage`
        if _data_type == "FunctionExecutionResultMessage":
            instance.actual_instance = FunctionExecutionResultMessage.from_json(json_str)
            return instance

        # check if data type is `SystemMessage`
        if _data_type == "SystemMessage":
            instance.actual_instance = SystemMessage.from_json(json_str)
            return instance

        # check if data type is `UserMessage`
        if _data_type == "UserMessage":
            instance.actual_instance = UserMessage.from_json(json_str)
            return instance

        # deserialize data into UserMessage
        try:
            instance.actual_instance = UserMessage.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SystemMessage
        try:
            instance.actual_instance = SystemMessage.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AssistantMessage
        try:
            instance.actual_instance = AssistantMessage.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into FunctionExecutionResultMessage
        try:
            instance.actual_instance = FunctionExecutionResultMessage.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into LlmMessage with oneOf schemas: AssistantMessage, FunctionExecutionResultMessage, SystemMessage, UserMessage. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into LlmMessage with oneOf schemas: AssistantMessage, FunctionExecutionResultMessage, SystemMessage, UserMessage. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AssistantMessage, FunctionExecutionResultMessage, SystemMessage, UserMessage]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


