# -*- coding: utf-8 -*-
# Generated by https://github.com/i2y/connecpy/protoc-gen-connecpy.  DO NOT EDIT!
# source: mtmai/mtmpb/events.proto

from typing import Any, Protocol, Union

import httpx

from connecpy.async_client import AsyncConnecpyClient
from connecpy.base import Endpoint
from connecpy.server import ConnecpyServer
from connecpy.client import ConnecpyClient
from connecpy.context import ClientContext, ServiceContext

import mtmai.mtmpb.events_pb2 as _pb2

from google.protobuf import symbol_database

_sym_db = symbol_database.Default()


class EventsService(Protocol):
    async def Push(self, req: _pb2.PushEventRequest, ctx: ServiceContext) -> _pb2.Event: ...
    async def BulkPush(self, req: _pb2.BulkPushEventRequest, ctx: ServiceContext) -> _pb2.Events: ...
    async def ReplaySingleEvent(self, req: _pb2.ReplayEventRequest, ctx: ServiceContext) -> _pb2.Event: ...
    async def PutLog(self, req: _pb2.PutLogRequest, ctx: ServiceContext) -> _pb2.PutLogResponse: ...
    async def PutStreamEvent(self, req: _pb2.PutStreamEventRequest, ctx: ServiceContext) -> _pb2.PutStreamEventResponse: ...


class EventsServiceServer(ConnecpyServer):
    def __init__(self, *, service: EventsService, server_path_prefix=""):
        super().__init__()
        self._prefix = f"{server_path_prefix}/mtmai.mtmpb.EventsService"
        self._endpoints = {
            "Push": Endpoint[_pb2.PushEventRequest, _pb2.Event](
                service_name="EventsService",
                name="Push",
                function=getattr(service, "Push"),
                input=_pb2.PushEventRequest,
                output=_pb2.Event,
                allowed_methods=("POST",),
            ),
            "BulkPush": Endpoint[_pb2.BulkPushEventRequest, _pb2.Events](
                service_name="EventsService",
                name="BulkPush",
                function=getattr(service, "BulkPush"),
                input=_pb2.BulkPushEventRequest,
                output=_pb2.Events,
                allowed_methods=("POST",),
            ),
            "ReplaySingleEvent": Endpoint[_pb2.ReplayEventRequest, _pb2.Event](
                service_name="EventsService",
                name="ReplaySingleEvent",
                function=getattr(service, "ReplaySingleEvent"),
                input=_pb2.ReplayEventRequest,
                output=_pb2.Event,
                allowed_methods=("POST",),
            ),
            "PutLog": Endpoint[_pb2.PutLogRequest, _pb2.PutLogResponse](
                service_name="EventsService",
                name="PutLog",
                function=getattr(service, "PutLog"),
                input=_pb2.PutLogRequest,
                output=_pb2.PutLogResponse,
                allowed_methods=("POST",),
            ),
            "PutStreamEvent": Endpoint[_pb2.PutStreamEventRequest, _pb2.PutStreamEventResponse](
                service_name="EventsService",
                name="PutStreamEvent",
                function=getattr(service, "PutStreamEvent"),
                input=_pb2.PutStreamEventRequest,
                output=_pb2.PutStreamEventResponse,
                allowed_methods=("POST",),
            ),
        }

    def serviceName(self):
        return "mtmai.mtmpb.EventsService"


class EventsServiceSync(Protocol):
    def Push(self, req: _pb2.PushEventRequest, ctx: ServiceContext) -> _pb2.Event: ...
    def BulkPush(self, req: _pb2.BulkPushEventRequest, ctx: ServiceContext) -> _pb2.Events: ...
    def ReplaySingleEvent(self, req: _pb2.ReplayEventRequest, ctx: ServiceContext) -> _pb2.Event: ...
    def PutLog(self, req: _pb2.PutLogRequest, ctx: ServiceContext) -> _pb2.PutLogResponse: ...
    def PutStreamEvent(self, req: _pb2.PutStreamEventRequest, ctx: ServiceContext) -> _pb2.PutStreamEventResponse: ...


class EventsServiceServerSync(ConnecpyServer):
    def __init__(self, *, service: EventsServiceSync, server_path_prefix=""):
        super().__init__()
        self._prefix = f"{server_path_prefix}/mtmai.mtmpb.EventsService"
        self._endpoints = {
            "Push": Endpoint[_pb2.PushEventRequest, _pb2.Event](
                service_name="EventsService",
                name="Push",
                function=getattr(service, "Push"),
                input=_pb2.PushEventRequest,
                output=_pb2.Event,
                allowed_methods=("POST",),
            ),
            "BulkPush": Endpoint[_pb2.BulkPushEventRequest, _pb2.Events](
                service_name="EventsService",
                name="BulkPush",
                function=getattr(service, "BulkPush"),
                input=_pb2.BulkPushEventRequest,
                output=_pb2.Events,
                allowed_methods=("POST",),
            ),
            "ReplaySingleEvent": Endpoint[_pb2.ReplayEventRequest, _pb2.Event](
                service_name="EventsService",
                name="ReplaySingleEvent",
                function=getattr(service, "ReplaySingleEvent"),
                input=_pb2.ReplayEventRequest,
                output=_pb2.Event,
                allowed_methods=("POST",),
            ),
            "PutLog": Endpoint[_pb2.PutLogRequest, _pb2.PutLogResponse](
                service_name="EventsService",
                name="PutLog",
                function=getattr(service, "PutLog"),
                input=_pb2.PutLogRequest,
                output=_pb2.PutLogResponse,
                allowed_methods=("POST",),
            ),
            "PutStreamEvent": Endpoint[_pb2.PutStreamEventRequest, _pb2.PutStreamEventResponse](
                service_name="EventsService",
                name="PutStreamEvent",
                function=getattr(service, "PutStreamEvent"),
                input=_pb2.PutStreamEventRequest,
                output=_pb2.PutStreamEventResponse,
                allowed_methods=("POST",),
            ),
        }

    def serviceName(self):
        return "mtmai.mtmpb.EventsService"


class EventsServiceClient(ConnecpyClient):
    def Push(
        self,
        *,
        request: _pb2.PushEventRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        **kwargs,
    ) -> _pb2.Event:
        method = "POST"
        return self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/Push",
            ctx=ctx,
            request=request,
            response_obj=_pb2.Event,
            method=method,
            **kwargs,
        )

    def BulkPush(
        self,
        *,
        request: _pb2.BulkPushEventRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        **kwargs,
    ) -> _pb2.Events:
        method = "POST"
        return self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/BulkPush",
            ctx=ctx,
            request=request,
            response_obj=_pb2.Events,
            method=method,
            **kwargs,
        )

    def ReplaySingleEvent(
        self,
        *,
        request: _pb2.ReplayEventRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        **kwargs,
    ) -> _pb2.Event:
        method = "POST"
        return self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/ReplaySingleEvent",
            ctx=ctx,
            request=request,
            response_obj=_pb2.Event,
            method=method,
            **kwargs,
        )

    def PutLog(
        self,
        *,
        request: _pb2.PutLogRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        **kwargs,
    ) -> _pb2.PutLogResponse:
        method = "POST"
        return self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/PutLog",
            ctx=ctx,
            request=request,
            response_obj=_pb2.PutLogResponse,
            method=method,
            **kwargs,
        )

    def PutStreamEvent(
        self,
        *,
        request: _pb2.PutStreamEventRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        **kwargs,
    ) -> _pb2.PutStreamEventResponse:
        method = "POST"
        return self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/PutStreamEvent",
            ctx=ctx,
            request=request,
            response_obj=_pb2.PutStreamEventResponse,
            method=method,
            **kwargs,
        )


class AsyncEventsServiceClient(AsyncConnecpyClient):
    async def Push(
        self,
        *,
        request: _pb2.PushEventRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        session: Union[httpx.AsyncClient, None] = None,
        **kwargs,
    ) -> _pb2.Event:
        method = "POST"
        return await self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/Push",
            ctx=ctx,
            request=request,
            response_obj=_pb2.Event,
            method=method,
            session=session,
            **kwargs,
        )

    async def BulkPush(
        self,
        *,
        request: _pb2.BulkPushEventRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        session: Union[httpx.AsyncClient, None] = None,
        **kwargs,
    ) -> _pb2.Events:
        method = "POST"
        return await self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/BulkPush",
            ctx=ctx,
            request=request,
            response_obj=_pb2.Events,
            method=method,
            session=session,
            **kwargs,
        )

    async def ReplaySingleEvent(
        self,
        *,
        request: _pb2.ReplayEventRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        session: Union[httpx.AsyncClient, None] = None,
        **kwargs,
    ) -> _pb2.Event:
        method = "POST"
        return await self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/ReplaySingleEvent",
            ctx=ctx,
            request=request,
            response_obj=_pb2.Event,
            method=method,
            session=session,
            **kwargs,
        )

    async def PutLog(
        self,
        *,
        request: _pb2.PutLogRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        session: Union[httpx.AsyncClient, None] = None,
        **kwargs,
    ) -> _pb2.PutLogResponse:
        method = "POST"
        return await self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/PutLog",
            ctx=ctx,
            request=request,
            response_obj=_pb2.PutLogResponse,
            method=method,
            session=session,
            **kwargs,
        )

    async def PutStreamEvent(
        self,
        *,
        request: _pb2.PutStreamEventRequest,
        ctx: ClientContext,
        server_path_prefix: str = "",
        session: Union[httpx.AsyncClient, None] = None,
        **kwargs,
    ) -> _pb2.PutStreamEventResponse:
        method = "POST"
        return await self._make_request(
            url=f"{server_path_prefix}/mtmai.mtmpb.EventsService/PutStreamEvent",
            ctx=ctx,
            request=request,
            response_obj=_pb2.PutStreamEventResponse,
            method=method,
            session=session,
            **kwargs,
        )
